local changed = false
local queueSlotIndex = 0
local queueNodeID = 0
local queueContinent = 0
local bypass = false
local dummyFrame=CreateFrame("FRAME");
local firstRun = false

WorldMapFrame:SetMapID("1")
dummyFrame:RegisterEvent("QUEST_LOG_UPDATE");--until map apis are finalized
dummyFrame:RegisterEvent("TAXIMAP_OPENED");
dummyFrame:RegisterEvent("ZONE_CHANGED_NEW_AREA");
dummyFrame:RegisterEvent("PLAYER_CONTROL_LOST");
dummyFrame:RegisterEvent("ADDON_LOADED");

SLASH_FQ1 = '/fq';
function SlashCmdList.FQ()
	queueSlotIndex = 0
	queueNodeID = 0
	print("|c0000FF00FlightQueue|r: cleared")
end

function GetCurrentMapContinent(relative)--until map apis are finalized
	local currentMapId = WorldMapFrame:GetMapID()
	if relative=="player" then
		currentMapId = C_Map.GetBestMapForUnit('player')
	end
	local continentInfo = MapUtil.GetMapParentInfo(currentMapId, Enum.UIMapType.Continent, true)
	if continentInfo then 
		return continentInfo.mapID
	else
		return 0
	end
end

function OnUpdateHandler(poi)
	poi:SetSize(24,24)
end

function OnEnterHandler(poi)
	for i in pairs(nodes) do
		if nodes[i].name == poi.name then
			GameTooltip:SetOwner (poi, "ANCHOR_RIGHT")
			GameTooltip:SetText ("|c0000FF00FlightQueue|r: "..nodes[i].name)
			GameTooltip:Show()
		end
	end
end
function ClickHandler(poi,button)
	local c= GetCurrentMapContinent()
	if button=="LeftButton" then
		for i in pairs(nodes) do
			if nodes[i].name == poi.name then
				if nodes[i].textureKitPrefix and string.find(poi.Texture:GetAtlas(), nodes[i].textureKitPrefix)==nil then
				else
					if queueSlotIndex == nodes[i].slotIndex then
						queueSlotIndex = 0
						queueNodeID = 0
						print("|c0000FF00FlightQueue|r: cleared")
						return
					elseif fcontinent[c]~=nil then
						queueSlotIndex = nodes[i].slotIndex
						queueNodeID = nodes[i].nodeID
						queueContinent = c
						print("|c0000FF00FlightQueue|r: "..nodes[i].name)
						return
					end
				end
			end
		end
		if fcontinent[c]==true then
			print("|c0000FF00FlightQueue|r: ".."You have not visited a flight master on this continent yet.")
		else
			print("|c0000FF00FlightQueue|r: "..TAXI_PATH_UNREACHABLE) --Not Discovered
		end
	end

end

function frameEventHandle(_,event,arg1)
	if event=="ADDON_LOADED" and arg1 == "FlightQueue" and fcontinent == nil then
		firstRun = true
	end
	if event == "ZONE_CHANGED_NEW_AREA" then
		changed = true
	end
	if event == "TAXIMAP_OPENED" then
		if nodes == nil then
			nodes = C_TaxiMap:GetAllTaxiNodes()
			for k in pairs(nodes) do 
				if nodes[k].state==Enum.FlightPathState.Unreachable then 
					nodes[k]=nil
				end
			end
		end
		local newnodes = C_TaxiMap:GetAllTaxiNodes()
		for k in pairs(newnodes) do
			if newnodes[k].state~=Enum.FlightPathState.Unreachable then 
				local mergeNode = true
				for K in pairs(nodes) do
					if nodes[K].nodeID == newnodes[k].nodeID then
						mergeNode = false
						nodes[K].state=newnodes[k].state
					end
				end
				if mergeNode == true then
					table.insert(nodes,newnodes[k])
				end
			end
		end
		fcontinent[GetCurrentMapContinent("player")]=false
		
		bypass=false
		local nodeState=1
		for k in pairs(nodes) do
			if nodes[k].nodeID==queueNodeID then
				nodeState=nodes[k].state
			end
		end
		if IsShiftKeyDown()~=true and queueSlotIndex > 0 and GetCurrentMapContinent("player")==queueContinent and nodeState==1 then
			TakeTaxiNode(queueSlotIndex);
			for i=1,8 do
				C_Timer.After(i/4,function () if UnitOnTaxi("player")==false then TakeTaxiNode(queueSlotIndex) end;end)--every 1/4 second for 2 seconds (8/4)
			end
		elseif IsShiftKeyDown() then
			bypass=true
		end
	end
	if event == "PLAYER_CONTROL_LOST" and bypass==false then
		if queueSlotIndex > 0 and GetCurrentMapContinent("player")==queueContinent then
			C_Timer.After(5,function ()
				if UnitOnTaxi("player") then
					queueSlotIndex = 0
					queueNodeID = 0
				end
			end)
		end
	end
	if event == "QUEST_LOG_UPDATE" then
		if changed or firstRun then
			local NewContinent = GetCurrentMapContinent("player")
			if fcontinent == nil then
				fcontinent={}
			end
			for k in pairs(fcontinent) do
				fcontinent[k]=false
			end
			if NewContinent>0 then
				if fcontinent[NewContinent]==nil then
					print("|c0000FF00FlightQueue|r: ".."New Continent. Visit a Flight Master to load new taxi nodes.")
				end
				fcontinent[NewContinent]=true
			end
			changed = false
		end
		if WorldMapFrame:IsVisible() and nodes~=nil then
			for pin in WorldMapFrame:EnumeratePinsByTemplate("GroupMembersPinTemplate") do 
				pin:SetFrameStrata("FULLSCREEN_DIALOG")
			end
			local _,nodeFrames = WorldMapFrame:EnumeratePinsByTemplate("FlightPointPinTemplate")
			for k in pairs(nodeFrames) do
				k:HookScript("OnEnter",OnEnterHandler)
				k:SetScript("OnMouseDown", ClickHandler)
				k:HookScript("OnLeave",function()
					GameTooltip_Hide()
				end)
				k:HookScript("OnUpdate",OnUpdateHandler)
				if WorldMapFrame:GetFrameStrata() == "FULLSCREEN" then
					k:SetFrameStrata("FULLSCREEN_DIALOG")
				else
					k:SetFrameStrata("DIALOG")
				end
			end
		end
	end
end
dummyFrame:SetScript("OnEvent",frameEventHandle);
